#lang racket

;; Loading modules:
;; (require "foo.rkt")
;;
;; (displayln a)
;; ; (displayln b)
;; (displayln c)


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Structs:

; Constructor
(struct point (x y z) #:transparent)
(define origin (point 0 0 0))

(define p (point "foo" #t (list 1)))
;; (displayln (point-x p)) ; p.x
;; (displayln (point-y p)) ; p.y
;; (displayln (point-z p)) ; p.z
#|
(define (point-set-x p x)
  (point x (point-y p) (point-z p)))|#

(define (point-set-x p x)
  (match p
    [(point _ old-y old-z)
      (point x old-y old-z)]
  ))

(define (point-to-string pt)
  (match pt
    [(point x y z)
      (format "{x=~a, y=~a, z=~a}" x y z)
      ]))

#|
;; (displayln p)
(displayln (point-set-x origin 1.0))
(displayln origin)
(displayln (point-to-string origin))

(struct r_number (value) #:transparent)

(r_number 10)

(r_number-value origin)|#


(displayln (exact-floor 2.3))

(define (map f l)
  (match l
    [(list) (list)]
    [(list h l ...)
      (define x (f h))
      (define result (map f l))
      (cons x result)
      ])
)

(define (exact-floor-list l)
  (define (f h)
    (exact-floor h))
  (map f l))

#|
(define (exact-floor-list l)
  (match l ; (list 1.1 2.3 12.3)
    [(list) (list)]
    [(list h l ...)
      ; h = 1.1
      (define x (exact-floor h))
      ; x = 1
      ; l = (list 2.3 12.3)
      ; (exact-floor-list l) =
      (define result (exact-floor-list l))
      ; result = (list 2 12)
      ; output: (list 1 2 12)
      (cons x result)
      ])
)
|#

;; Abbridged version:
;; (define (exact-floor-list l)
;;   (match l
;;     [(list) (list)]
;;     [(list h l ...)
;;       (cons (exact-floor h) (exact-floor-list l))
;;     ])
;; )
#|
;; ; Given
(exact-floor-list
  (list 1.1 2.3 12.3))
; Expected
(list
  (exact-floor 1.1)   ; 1
  (exact-floor 2.3)   ; 2
  (exact-floor 12.3)) ; 12|#
#|
(define (double-list l)
  (match l ; (list 3 5 7)
    [(list) (list)]
    [(list h l ...)
      ; h = 3
      (define x (* h 2))
      ; x = 6
      ; l = (list 5 7)
      (define result (double-list l))
      ; result = (list 10 14)
      ; output = (list 6 10 14)
      (cons x result)
    ]
  )
  )|#

(define (double-list l)
  (map (lambda (h)
    (* h 2)
  ) l))

; Given
(double-list
  (list 3 5 7))
; Expected
(list
  (* 2 3)  ; 6
  (* 2 5)  ; 10
  (* 2 7)) ; 14














